#pragma once
#include "EnemyBase.h"

namespace Bazooka01
{
	const int HP_MAX = 30;				// HP
	const double SPEED = 3.3;			// ړXs[h
	const double TURN_SPEED = 0.05;		// Xs[h

	const int BAZOOKA_TIME = 60;		// U̎
	const int BAZOOKA_DELAY = 90;		// U̍d
	const double BAZOOKA_RAD = 12.0;	// e̔a
	const int BAZOOKA_POWER = 15;		// ëЗ
	const int BAZOOKA_LIMIT = 50;		// ؋󎞊
	const fk_Vector BAZOOKA_SPEED(0.0, 0.0, -8.0);	// e

	const double ATTACK_DIST = 400.0;	// U̓K
	const double ALLOW_DIST = 50.0;		// K̋e

	const double EXPLOSION_PRIMAL_SIZE = 30.0;	// ̏TCY
	const int EXPLOSION_LIMIT = 20;				// ܂ł̎
	const int EXPLOSION_CREATE_TIME = 8;		// L鎞
	const double EXPLOSION_SPREAD_SIZE = 10.0;	// t[ɍL傫

	enum Timer
	{
		ATTACK_TIMER,
		MOVE_TIMER,
		BAZOOKA_TIMER,
		EXPLOSION_TIMER,
		TIMER_MAX
	};
}

class C_Bazooka01 : public C_EnemyBase
{
private:

public:
	C_Bazooka01(fk_Scene *, fk_Model *, C_MapBase *, C_Boy *, C_Girl *);
	~C_Bazooka01();

	void	move();		// ړ
	void	attack();	// U
};