#pragma once
#include "EnemyBase.h"

namespace Boss01_Fist_R
{
	const int WAVE_POWER = 50;				// EF[üЗ
	const double WAVE_PRIMAL_SIZE = 30.0;	// EF[ȕTCY
	const double WAVE_SPREAD_SIZE = 10.0;	// EF[ut[ɍL傫
	const int WAVE_CREATE_TIME = 10;		// EF[uL鎞
	const int WAVE_LIMIT = 20;				// EF[u܂ł̎

	const int MOW_POWER = 100;				// ガ̈З
	const int MOW_LIMIT = 20;				// ガ̓蔻肪܂ł̎

	enum Timer
	{
		GRAND_TIMER,
		WAVE_TIMER,
		MOW_TIMER,
		FALL_TIMER1,	// 1iKڂ̃_E
		FALL_TIMER2,	// 2iKڂ̃_E
		TIMER_MAX
	};
}

class C_Boss01_Fist_R : public C_EnemyBase
{
private:
	int		*trueHp;	// *hpłCharacterNXhpgႢtrueHp

public:
	C_Boss01_Fist_R(fk_Scene *, fk_Model *, C_MapBase *, C_Boy *, C_Girl *);
	~C_Boss01_Fist_R();

	fkut_SpriteModel	marker;

	void move();		// ړ
	void attack();		// U

	void procDamage();	// UꂽƂ̏

	void replaceHp(int *argHp);	// {X{̂HPƋL
};