#pragma once

class C_Boy;		// zQƂ̖h~
class C_Girl;

#include "Character.h"

namespace EnemyBase
{
	enum LockTarget
	{
		NONE,
		BOY,
		GIRL,
		TARGET_MAX
	};

	const double GAUGE_SIZE_X = 100.0;		// HPQ[W̉
	const double GAUGE_SIZE_Y = 10.0;		// HPQ[W̏c
}

class C_EnemyBase : public C_Character
{
protected:
	C_Boy		*boy;
	C_Girl		*girl;

	int			lockTarget;					// 0: N_ĂȂԁA1: boy_ԁA2: girl_
	//int			state;						// 
	int			movePattern, attackPattern;	// ړƍŨp^[
	double		distToBoy, distToGirl;		// boy, girlƂ̋
	bool		isHeavy;					// vC[ȂdGǂ
	bool		isLock;						// UΏۂ𐳖ʂɑĂ邩ǂ
	bool		isBoot;						// AIsJnĂ邩ǂ
	bool		isCollision;				// ݂falseƓGm̏Փ˔肪ȂȂ
	bool		lockAble;					// falseɂgirlbNIłȂ

	//static std::vector<C_EnemyBase*>* enemies;

public:
	C_EnemyBase(fk_Scene *, fk_Model *, C_MapBase *, C_Boy *, C_Girl *);
	virtual ~C_EnemyBase();

	vector<fkut_BlockModel *>	shield;		// ̓Gp

	virtual void	procDamage();	// UꂽƂ̏

	void	updateDistToPlayer();	// boy, girlƂ̋XV
	double	getDistToBoy();
	double	getDistToGirl();

	bool	getIsHeavy();
	bool	getIsLock();
	bool	getIsCollision();

	void	setIsBoot(bool);
	bool	getIsBoot();

	void	setLockAble(bool);
	bool	getLockAble();

	int		lockNear();		// ߂̃vC[_
	int		lockFar();		// ̃vC[_
	int		lockBoy();		// {Iboy_
	int		lockGirl();		// {Igirl_
	int		lockRandom();	// _Ō߂

	void	turnToBoy(double turnSpeed);	// boy̕ɐ񂷂
	void	turnToGirl(double turnSpeed);	// girl̕ɐ񂷂
};