#include "GameOver.h"

C_GameOver::C_GameOver(fk_Window *argWin, C_EventManager *argEve, int argStageNum)
: C_SceneBase(argWin, argEve)
, cursorPos(0)
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);

	// effBXvCXgɓo^
	scene.entryModel(&lightModel);

	// ǂ̃V[痈̂
	sceneNum = argStageNum;

	// vC[HPƃ_E񐔂l
	C_Boy::BOY_HP = Boy::HP_MAX;
	C_Girl::GIRL_HP = Girl::HP_MAX;
	C_Boy::DEATH_NUM = 0;

	// J[\
	cursor.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	cursor.text.setPTSize(32);
	cursor.drawText("");
	//cursor.setPositionLT(-80.0, 300.0);
	cursor.glMoveTo(-150.0, 50.0 - cursorPos * 50.0, 0.0);
	cursor.entryFirst(ref_window, &scene, &camera);

	// j[
	for(int i = 0; i < sizeof(strList) / sizeof(strList[0]); ++i)
	{
		strList[i].initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
		strList[i].text.setPTSize(32);
	}

	strList[0].drawText("gC");
	strList[1].drawText("^Cgɖ߂");

	for(int i = 0; i < sizeof(strList) / sizeof(strList[0]); ++i)
	{
		//strList[i].setPositionLT(-50.0, 50.0 - i * 50.0);
		strList[i].glMoveTo(0.0, 50.0 - i * 50.0, 0.0);
		strList[i].entryFirst(ref_window, &scene, &camera);
	}

	sound.b_setAllVolume(sound.b_getAllVolume());	// BGM̉ʂZbg

	//fadeIn(true, 30, false, b_title, b_debug);
	fadeIn(true, 30);

	//Fl::check();
}

C_GameOver::~C_GameOver(void)
{
	//fadeOut(true, 30, true, b_title, b_debug);
	//sound.b_stop(b_title);
	//sound.b_stop(b_debug);
	fadeOut(true, 30);
}

int	C_GameOver::onPeriod(void)
{
	// J[\̏cړ																		L[{[hp
	if(controller[0].KeyDown(X_GAMEPAD_LS_DOWN) || controller[0].KeyDown(X_GAMEPAD_DOWN) || ref_event->getSpecialKeyStatus(FK_DOWN) == FKUT_SW_DOWN)
	{
		if(cursorPos == GameOver::STR_MAX - 1)	cursorPos = 0;
		else									cursorPos++;

		//cursor.setPositionLT(-80.0, 300.0 - cursorPos * 30.0);
		cursor.glMoveTo(-150.0, 50.0 - cursorPos * 50.0, 0.0);

		sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
	}

	if(controller[0].KeyDown(X_GAMEPAD_LS_UP) || controller[0].KeyDown(X_GAMEPAD_UP) || ref_event->getSpecialKeyStatus(FK_UP) == FKUT_SW_DOWN)
	{
		if(cursorPos == 0)	cursorPos = GameOver::STR_MAX - 1;
		else				cursorPos--;

		//cursor.setPositionLT(-80.0, 300.0 - cursorPos * 30.0);
		cursor.glMoveTo(-150.0, 50.0 - cursorPos * 50.0, 0.0);

		sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
	}

	if(controller[0].KeyDown(X_GAMEPAD_A) || ref_event->getKeyStatus('Z') == FKUT_SW_DOWN)
	{
		sound.se_on(SE_DECISION);	// 艹̉

		switch(cursorPos)
		{
		case GameOver::RETRY:
			return sceneNum;
		case GameOver::RETURN_TITLE:
			return TITLE;
		}
	}

	return 0;
}