#pragma once
#include "SceneBase.h"
#include "Boy.h"
#include "Girl.h"

namespace GameOver
{
	enum Str
	{
		RETRY,
		RETURN_TITLE,
		STR_MAX
	};
}

class C_GameOver : public C_SceneBase
{
private:
	fk_Model			lightModel;
	fk_Light			light;

	fkut_SpriteModel	cursor;
	int					cursorPos;

	fkut_SpriteModel	strList[GameOver::STR_MAX];

public:
	C_GameOver(fk_Window *, C_EventManager *, int argStageNum);
	~C_GameOver(void);

	// V[vZXs
	int	onPeriod(void);
};