#pragma once

class C_Boy;		// zQƂ̖h~
class C_EnemyBase;

#include "Character.h"
#include "XController.h"

#include <boost/range/algorithm.hpp>

namespace Girl
{
	const int HP_MAX = 500;				// HP
	const double GIRL_SPEED = 4.0;		// ړXs[h

	const int MACHINE_GUN_DELAY = 30;	// Ƀ}VKĂ悤ɂȂ܂ł̎
	const int MACHINE_GUN_INTERVAL = 6;	// }VK̒e̊Ԋu((MACHINE_GUN_DELAYMACHINE_GUN_INTERVAL)1xɘA˂e̐)

	const double MACHINE_GUN_RAD = 5.0;	// }VK̒e̔a
	const int MACHINE_GUN_POWER = 1;	// ëЗ
	const int MACHINE_GUN_LIMIT = 80;	// ؋󎞊
	const fk_Vector MACHINE_GUN_SPEED(0.0, 0.0, -15.0);	// e
	const double TURN_SPEED = 0.02;		// e̐Xs[h

	const int LASER_DELAY = 50;			// [U[̃fBC
	const int CHARGE_COMP_TIME = 60;	// [U[̃`[W܂ł̎
	const int LASER_CREATE_TIME = 5;	// [U[Ȃ鎞

	const double LASER_THICK = 20.0;	// [U[̑
	const double LASER_PRIMAL_LENGTH = 10.0;		// [U[̏
	const int LASER_POWER = 3;			// [U[̈З
	const int LASER_LIMIT = 120;		// ؋󎞊(LASER_DELAY*2 + MACHINE_GUN_DELAY傫lɂȂ)
	const fk_Vector LASER_SPEED(0.0, 0.0, -55.0);	// e

	const double GAUGE_POS_X = -320.0;	// HPQ[WXW
	const double GAUGE_POS_Y = 300.0;	// HPQ[WYW
	//const double GAUGE_SIZE_COEF = 0.5;	// HPQ[W̌W
	const double GAUGE_SIZE_X = 250.0;	// HPQ[W̉
	//const double GAUGE_SIZE_Y = 10.0;	// HPQ[W̏c

	enum Timer
	{
		ATTACK_DELAY_TIMER,
		MACHINE_GUN_TIMER,		// }VK̔˂Ǘ
		CHARGE_TIMER,			// [U[̃`[W
		LASER_TIMER,			// [U[̔˂Ǘ
		LOCK_TIMER,				// bNĂ鎞
		HEAL_TIMER,
		TIMER_MAX
	};
}

class C_Girl : public C_Character
{
private:
	// L̕ݒ̂߂̕ϐ
	double	LX;
	double	LY;
	double	magnitudeL;

	bool			lock_flag;				// bNĂ邩ǂ
	unsigned int	lockSwitchNum;			// bN̐؂ւ
	bool			lockOrder_flag;			// bN鏇Ԃ߂Ɍ肷鎞trueɂ
	bool			lockOrderAdjust_flag;	// bNĂGȊO|trueɂ
	int				lockEnemyId;			// bNĂGID
	unsigned int	lockEnemyIndex;			// bNĂG̔z̏
	fkut_ConeModel	lockPointer;			// bNĂG̓ɏoR[f

	bool			nextShot_flag;			// }VKIɂxǂ

	fk_Vector		lockVec;				// bNĂǗ

	C_Boy					*boy;
	vector<C_EnemyBase *>	*enemyArray;

public:
	C_Girl(fk_Scene *, fk_Model *, C_MapBase *, C_Boy *, vector<C_EnemyBase *> *);
	~C_Girl();

	// V[؂ւĂvC[HPƃ_E񐔂p߁AÓIoϐɂĂ
	// ʏC_CharacterhpgAV[؂ւɂɕۑĂ
	static int GIRL_HP;

	void	move();		// ړ
	void	attack();	// U
	void	lockon();	// bNȈ
	void	heal();		// 

	void	procDamage();	// UꂽƂ̏

	vector<int>		lockOrder;				// bN鏇ԂǗ(GID)
	void			setLock_flag(bool);		// bNtOݒ肷
	bool			getLock_flag();			// bNĂ邩ǂԂ

	//unsigned int	getLockSwitchNum();		// lockSwitchNumԂ

	//vector<int>	getLockOrder();			// lockOrderԂ

	void	setLockOrder_flag(bool);		// bN鏇ԂύXAtrueZbg
	bool	getLockOrder_flag();			// lockOrder_flagԂ

	void	setLockOrderAdjust_flag(bool);	// bNĂGȊO|trueZbg
	bool	getLockOrderAdjust_flag();		// lockOrderAdjust_flagԂ

	void	setLockEnemyId(int);			// bNGIDZbg
	int		getLockEnemyId();				// bNĂGIDԂ
};