#pragma once
#include "FKUT/CubicModel.h"

class C_HitSphereModel : public fkut_SphereModel
{
protected:
	fk_Vector		spd;
	int				power;
	bool			isCE;		// ǂ
	int				kind;		// U̎
	int				index;		// z̔ԍ

	int				limit;		// ł܂ł̎
	bool			limit_flag;	// ŎԂtrue

	int				expTime;	// p̎ԁiɃ~TCpj
	int				target;		// _GiɃ~TCpj

public:
	C_HitSphereModel(double argRad, int argPower, int argLimit, fk_Vector argSpd, bool argCE_flag, int argKind = -1, int argIndex = 0);
	C_HitSphereModel(double argRad, int argPower, int argLimit, bool argCE_flag, int argKind = -1, int argIndex = 0);
	virtual ~C_HitSphereModel();

	void			setSpd(fk_Vector argSpd);
	fk_Vector		getSpd();

	void			setPower(int argPower);
	int				getPower();

	void			setCE_flag(bool argFlag);
	bool			getCE_flag();

	void			setKind(int argKind);
	int				getKind();

	void			setIndex(int argIndex);
	int				getIndex();

	void			setLimit(int argLimit);
	int				getLimit();

	void			setLimit_flag(bool argFlag);
	bool			getLimit_flag();

	void			setExpTime(int argTime);
	int				getExpTime();

	void			setTarget(int argTarget);
	int				getTarget();

	void			setRad(double argRad);	// aargRad̋Đ
	double			getRad();

	bool			cntLimit();		// limit炵A0ɂȂtrueԂ
	bool			cntExpTime();	// expTime炵A0ɂȂtrueԂ

	virtual	void	move();

	// 蔻菈
	void			procHit(fkut_SphereModel *sphere);	// Փˏ(߂)s
	bool			isHit(fkut_SphereModel *sphere);	// Ă邩ǂ
};