#pragma once
#include "GLSLModel.h"
#include "FKUT/CubicModel.h"
#include "FKUT/Misc.h"
#include "Function.h"
#include "XFile.h"

class C_MapBase
{
private:
	map<string, fk_Material>	colors;			// F̘Azz

public:
	C_MapBase();
	virtual ~C_MapBase();

	GLSLModel			model;
	C_DX3File			xfile;

	vector<fkut_BlockModel *>	block;			// ubN̔z
	fk_Vector LTPos, LBPos, RTPos, RBPos;		// EBhE̍W3ԍWɂĂ󂯎邽߂̕ϐ
	double	sectionWallDist;					// Ԃ̕ǂ̋
	fkut_BlockModel				bootWall[2];	// AIN邽߂̕
	int		leftWallIndex, rightWallIndex;		// E̕ǂblockz̉Ԗڂɂ邩

	bool	load(const string &cfgFileName);		// }bvf[^̓ǂݍ
	void	createSectionWall(fk_Window *argWin, fkut_BlockModel *argCameraPoint);	// Ԃ̕ǂ
	//void	adjustSectionWall(fk_Window *argWin);	// Ԃ̕ǂĒ

	// V[\E\
	void entryScene(fk_Scene *);
	void removeScene(fk_Scene *);

	// 蔻菈
	void procHit(fkut_BlockModel *OBB, fk_Vector *spd);						// Փˏ(߂)s(OBBp)
	bool procHit(fkut_BlockModel *OBB, fk_Vector *spd, fk_Vector *back);	// [U[p
	void procHit(fkut_SphereModel *sphere, fk_Vector *spd);					// Փˏ(߂)s(p)
	void procHit_forGirl(fkut_SphereModel *sphere, fk_Vector *spd);			// girlbNIĂ鎞̏Փˏ(߂)
	bool isHit(fkut_BlockModel *OBB);										// Ă邩ǂ(OBBp)
	bool isHit(fkut_SphereModel *sphere);									// Ă邩ǂ(p)
	bool isHit(fkut_SphereModel *sphere, fk_Vector spd);					// Ă邩ǂ(p, spdt)
	bool isHit_rightWall(fkut_SphereModel *sphere);							// E(is)̕ǂɓĂ邩ǂ(p)
	bool isHit_bootWall(fkut_SphereModel *sphere);							// AINp̕ǂɓĂ邩ǂ(p)
};