#pragma once
#include <GL/glew.h>
#include "EventManager.h"
//#include "FKUT/Audio.h"
#include "FKUT/SpriteModel.h"
#include "Sound.h"

/* VV[ǉɕύXt@C
SceneBase.h, GameMain.h, GameMain.cpp, Debug.h, Debug.cpp
*/

enum SceneList
{
	NULL_SCENE,
	TITLE,
	STAGE1_1A,
	STAGE1_1B,
	STAGE1_2,
	STAGE1_3,
	GAME_CLEAR,
	GAME_OVER,
	DEBUG_MODE = 99
};

// EBhETCY
const int WINDOW_WIDTH = 1280;
const int WINDOW_HEIGHT = 720;

const double EPS = 0.0000001;	// 덷h߂̒萔

class C_SceneBase
{
protected:
	fk_Window		*ref_window;
	C_EventManager	*ref_event;
	fk_Scene		scene;
	fk_Model		camera;
	//fk_Perspective	pers;
	
	fkut_SpriteModel	blackScreen;
	fkut_SpriteModel	whiteScreen;

	int					sceneNum;	// Q[I[o[ʂ烊gCƂɎgp
	int					b_state;	// BGM؂ւ邽߂̃tO

public:
	C_SceneBase(fk_Window *, C_EventManager *);
	virtual ~C_SceneBase(void);

	// V[vZXs
	// Ԓl0ł̃V[p
	// Ԓl-1ňُI
	// ȊO̒lŎw肵V[ɑJ
	virtual int	onPeriod(void) = 0;

	int			getStageNum();	// stgaeNumԂ

	// tF[hCEAEg
	// 1͍FtF[hǂ
	// 2ɂ̓tF[h̎
	// 3BGMtF[h邩ǂ(ftHgŃtF[hȂ)
	// 4ȍ~͂̃V[Ŏg(g)BGM̖O
	void		fadeIn	(bool isBlack, int time, bool b_fade = false, int b_num1 = -1, int b_num2 = -1, int b_num3 = -1);
	void		fadeOut	(bool isBlack, int time, bool b_fade = false, int b_num1 = -1, int b_num2 = -1, int b_num3 = -1);
};