#include "Stage1_1A.h"

C_Stage1_1A::C_Stage1_1A(fk_Window *argWin, C_EventManager *argEve)
: C_StageBase(argWin, argEve)
{
	sceneNum = STAGE1_1A;

	// JnXe[WȂ̂ŃvC[HPƃ_E񐔂l
	boy.setHp(Boy::HP_MAX);
	girl.setHp(Girl::HP_MAX);
	boy.setDeathNum(0);
	boy.green_bar.setSpriteSize(Boy::GAUGE_SIZE_X);		// boy̗΃Q[W̕ݒ
	boy.green_bar.glMoveTo(Boy::GAUGE_POS_X, Boy::GAUGE_POS_Y, 0.0);
	girl.green_bar.setSpriteSize(Girl::GAUGE_SIZE_X);	// girl̗΃Q[W̕ݒ
	girl.green_bar.glMoveTo(Girl::GAUGE_POS_X, Girl::GAUGE_POS_Y, 0.0);

	// J̈ʒuƊpx
	//camera.glMoveTo(0.0, 580.0, 635.0);
	//camera.glAngle(0.0, -0.65, 0.0);

	// }bvf[^̓ǂݍ
	map.load("Data/Map/1_1A.csv");
	map.createSectionWall(argWin, &cameraPoint);

	// }bvf{wi
	//map.model.setMaterial(MatBlack);
	map.model.setMaterial(White);
	map.model.getMaterial()->setSpecular(1.0, 1.0, 1.0);
	map.model.getMaterial()->setShininess(20.0);
	map.xfile.load("Data/CG/Map/1_1A.x", "Data/CG/Map/1_1A_tex.png");
	map.model.setShape(&map.xfile.DX3_IFSTexture);
	map.model.initShader("Data/Shader/Gourand.vert", "Data/Shader/Gourand.frag");
	//map.model.setTexUse(true);	// eNX`g[h
	map.model.glMoveTo(1100.0, -76.0, -20.0);
	map.model.setScale(130.0);
	//map.model.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	//map.model.getMaterial()->setEmission(1.0, 1.0, 1.0);

	map.entryScene(&scene);

	// Gf[^̓ǂݍ
	loadEnemyData("Data/Map/1_1A_EnemyData.csv");

	// vC[̕\
	boy.getBody()->glTranslate(20.0, 0.0, 0.0);
	boy.entryScene(&scene, argWin, &camera);
	girl.getBody()->glTranslate(-20.0, 0.0, 0.0);
	girl.entryScene(&scene, argWin, &camera);

	// G̕\
	for(unsigned int i = 0; i < enemyArray.size(); ++i)	enemyArray.at(i)->entryScene(&scene);

	sound.b_setAllVolume(sound.b_getAllVolume());	// BGM̉ʂZbg

	fadeIn(true, 30, false, B_STAGE1_1);
}

C_Stage1_1A::~C_Stage1_1A(void)
{
	fadeOut(true, 30, true, B_STAGE1_1);
	sound.b_stop(B_STAGE1_1);
}

int	C_Stage1_1A::onPeriod(void)
{
	sound.b_play(B_STAGE1_1);

	// |[YłȂ
	if(pause_flag == false)
	{
		// Ԃ̈ړ
		procSectionMove();
	}

	// Xe[Wʂ̏
	return procCommon();
}