#include "Stage1_1B.h"

C_Stage1_1B::C_Stage1_1B(fk_Window *argWin, C_EventManager *argEve)
: C_StageBase(argWin, argEve)
{
	sceneNum = STAGE1_1B;

	// }bvf[^̓ǂݍ
	map.load("Data/Map/1_1B.csv");
	map.createSectionWall(argWin, &cameraPoint);

	// }bvf{wi
	map.model.setMaterial(White);
	map.model.getMaterial()->setSpecular(1.0, 1.0, 1.0);
	map.model.getMaterial()->setShininess(20.0);
	map.xfile.load("Data/CG/Map/1_1A.x", "Data/CG/Map/1_1A_tex.png");
	map.model.setShape(&map.xfile.DX3_IFSTexture);
	map.model.initShader("Data/Shader/Gourand.vert", "Data/Shader/Gourand.frag");
	//map.model.setTexUse(true);	// eNX`g[h
	map.model.glMoveTo(1100.0, -76.0, -20.0);
	map.model.setScale(130.0);
	//map.model.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	//map.model.getMaterial()->setEmission(1.0, 1.0, 1.0);

	map.entryScene(&scene);

	// Gf[^̓ǂݍ
	loadEnemyData("Data/Map/1_1B_EnemyData.csv");

	// vC[̕\
	boy.getBody()->glTranslate(20.0, 0.0, 0.0);
	boy.entryScene(&scene, argWin, &camera);
	girl.getBody()->glTranslate(-20.0, 0.0, 0.0);
	girl.entryScene(&scene, argWin, &camera);

	// G̕\
	for(unsigned int i = 0; i < enemyArray.size(); ++i)	enemyArray.at(i)->entryScene(&scene);

	sound.b_setAllVolume(sound.b_getAllVolume());	// BGM̉ʂZbg

	fadeIn(true, 30, false, B_STAGE);
}

C_Stage1_1B::~C_Stage1_1B(void)
{
	fadeOut(true, 30, true, B_STAGE);
	sound.b_stop(B_STAGE);
}

int	C_Stage1_1B::onPeriod(void)
{
	sound.b_play(B_STAGE);

	// |[YłȂ
	if(pause_flag == false)
	{
		// Ԃ̈ړ
		procSectionMove();
	}

	// Xe[Wʂ̏
	return procCommon();
}