#include "Stage1_3.h"

C_Stage1_3::C_Stage1_3(fk_Window *argWin, C_EventManager *argEve)
: C_StageBase(argWin, argEve)
{
	sceneNum = STAGE1_3;

	map.load("Data/Map/1_3.csv");
	map.entryScene(&scene);

	// vC[̕\
	boy.getBody()->glTranslate(20.0, 0.0, 0.0);
	boy.entryScene(&scene, argWin, &camera);
	girl.getBody()->glTranslate(-20.0, 0.0, 0.0);
	girl.entryScene(&scene, argWin, &camera);

	// {X₷悤ɃJ̈ʒuς
	camera.glMoveTo(0.0, 800.0, 500.0);
	camera.glAngle(0.0, -0.8, 0.0);
	//camera.glFocus(0.0, 0.0, 0.0);
	primalCameraPos = camera.getPosition();

	// G̐
	// {X01
	enemyArray.push_back(new C_Boss01(&scene, &camera, &map, &boy, &girl, &enemyArray, &itEnemyArray, &totalEnemyNum));

	// AZgltranslate, glVec
	enemyArray.back()->getBody()->glTranslate(0.0, 0.0, -800.0);
	enemyArray.back()->getBody()->glVec(0.0, 0.0, 1.0);
	//enemyArray.back()->getBody()->loFocus(0.0, 0.0, 1.0);
	//enemyArray.back()->updateDistToPlayer();
	enemyArray.back()->setId(totalEnemyNum);
	++totalEnemyNum;
	enemyArray.back()->entryScene(&scene);

	enemyArray.back()->green_frame.entryFirst(ref_window, &scene, &camera);
	enemyArray.back()->green_bar.entryFirst(ref_window, &scene, &camera);

	// G̕\
	//for(unsigned int i = 0; i < enemyArray.size(); ++i)	enemyArray.at(i)->entryScene(&scene, argWin, &camera);
	
	// {̈ȊO̓蔻p̋̂o
	for(unsigned int i = 0; i < enemyArray.size() - 1; ++i)	scene.entryModel(enemyArray.at(i)->getBody());

	sound.b_setAllVolume(sound.b_getAllVolume());	// BGM̉ʂZbg

	fadeIn(true, 30, false, B_BOSS1);
}

C_Stage1_3::~C_Stage1_3(void)
{
	fadeOut(true, 30, true, B_BOSS1);
	sound.b_stop(B_BOSS1);
}

// J̈ړ
void C_Stage1_3::cameraMove()
{
	// J̒_ړ
	cameraPoint.glMoveTo((boy.getPos().x + girl.getPos().x) / 2.0, 0.0, (boy.getPos().z + girl.getPos().z) / 2.0);

	if((boy.getPos() - girl.getPos()).dist() >= 350.0)
	{
		zoomOutDist = ((boy.getPos() - girl.getPos()).dist() - 350.0);
	}
	camera.glMoveTo(primalCameraPos.x, primalCameraPos.y + zoomOutDist, primalCameraPos.z + zoomOutDist);
}

int	C_Stage1_3::onPeriod(void)
{
	sound.b_play(B_BOSS1);

	// {X|AQ[NAʂ֑Jڂ
	if(timer.at(StageBase::GAME_CLEAR_TIMER).getTime() == 0)	return GAME_CLEAR;
	if(enemyArray.size() == 0 && timer.at(StageBase::GAME_CLEAR_TIMER).getTime() < 0)	timer.at(StageBase::GAME_CLEAR_TIMER).setTime(180);

	// Xe[Wʂ̏
	return procCommon();
}