#pragma once
#include "SceneBase.h"

namespace Title
{
	enum Str
	{
		GAME_START,
		OPTION,
		EXIT,
		STR_MAX
	};
}

namespace Option 
{
	enum Str
	{
		BGM_VOLUME,
		SE_VOLUME,
		VIBRATION,
		ACTION_TYPE,
		OK,
		STR_MAX
	};
}

const double VOLUME_GAUGE = 300.0;	// {[Q[W̉

class C_Title : public C_SceneBase
{
private:
	fk_Model			lightModel;
	fk_Light			light;

	fkut_SpriteModel	telop;

	// ^Cg
	fkut_SpriteModel	titleImg;
	fkut_SpriteModel	ti_cursor;
	int					ti_cursorPos;

	fkut_SpriteModel	ti_str[Title::STR_MAX];

	// IvV
	bool				option_flag;
	fkut_SpriteModel	optionImg;
	fkut_SpriteModel	op_cursor;
	int					op_cursorPos;

	fkut_SpriteModel	b_volumeImg, se_volumeImg;
	fkut_SpriteModel	op_str[Option::STR_MAX];
	fkut_SpriteModel	vib_on, vib_off;
	fkut_SpriteModel	type_auto, type_manual;

public:
	C_Title(fk_Window *, C_EventManager *);
	~C_Title(void);

	// V[vZXs
	int	onPeriod(void);
};