#include "GameMain.h"

class GLEW_Window : public fk_Window
{
public:
	GLEW_Window(int x = 0, int y = 0, int w = 300, int h = 300, std::string name = "")
		: fk_Window(x, y, w, h, name) {};
	
	void preInit(void)
	{
		GLenum err = glewInit();
		if(err != GLEW_OK)
		{
			cout << "GLEW ERROR!" << endl;
			exit(1);
		}
	};
};

int main(int argc, char *argv[])
{
	// [No
	_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);

	Fl_Window	mainWin(3, 28, WINDOW_WIDTH, WINDOW_HEIGHT, "TAG HEROES");
	GLEW_Window	drawWin(0, 0, WINDOW_WIDTH, WINDOW_HEIGHT);

	C_GameMain	gameMain(&mainWin, &drawWin);

	return gameMain.run();
}