#include "Boy.h"
#include "Girl.h"
#include "Bazooka01.h"

using namespace EnemyBase;
using namespace Bazooka01;

C_Bazooka01::C_Bazooka01(fk_Scene *argScene, fk_Model *argCamera, C_MapBase *argMap, C_Boy *argBoy, C_Girl *argGirl)
: C_EnemyBase(argScene, argCamera, argMap, argBoy, argGirl)
{
	hp = hp_max = HP_MAX;
	body.create(6, 30.0);
	body.glMoveTo(0.0, 30.0, 0.0);
	body.setMaterial(White);
	//body.setMaterial(Orange);
	body.getMaterial()->setSpecular(0.0, 0.8, 0.4);
	body.getMaterial()->setShininess(100.0);

	xfile.DX3_IFSTexture.cloneShape(&xModel.model[X_BAZOOKA01].DX3_IFSTexture);
	model.setShape(&xfile.DX3_IFSTexture);
	model.initShader("Data/Shader/Blinn.vert", "Data/Shader/Blinn.frag");
	model.setScale(50.0);
	model.setParent(&body, true);

	timer.resize(TIMER_MAX);
}

C_Bazooka01::~C_Bazooka01()
{
}

// ړ
void C_Bazooka01::move()
{
	spd.init();				// ړx0ɖ߂
	updateDistToPlayer();	// vC[Ƃ̋XV

	// Û߂ɋ߂Â
	if(timer.at(ATTACK_TIMER).getTime() <= 0)
	{
		lockTarget = lockNear();	// ߂_

		// ړ̃^C}[JEgĂ
		timer.at(MOVE_TIMER).setTime(timer.at(MOVE_TIMER).getTime() + 1, false);

		// lockTargetɉčsς
		if(lockTarget == BOY)
		{
			turnToBoy(TURN_SPEED);	// 

			// Ə͍Ă邯ǁAKȂČĂȂ܂ܒԌoOɌ
			if(getIsLock() && timer.at(MOVE_TIMER).getTime() >= 120)
			{
				timer.at(ATTACK_TIMER).setTime(BAZOOKA_TIME + BAZOOKA_DELAY);
				timer.at(BAZOOKA_TIMER).setTime(BAZOOKA_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
			// Ă
			else if(distToBoy > ATTACK_DIST + ALLOW_DIST)
			{
				spd.z = -SPEED;	// ߂Â
			}
			// ߂
			else if(distToBoy < ATTACK_DIST - ALLOW_DIST)
			{
				spd.z = SPEED;	// 
			}
			else if(getIsLock())	// KɋāAƏĂ΍U
			{
				timer.at(ATTACK_TIMER).setTime(BAZOOKA_TIME + BAZOOKA_DELAY);
				timer.at(BAZOOKA_TIMER).setTime(BAZOOKA_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
		}
		else if(lockTarget == GIRL)
		{
			turnToGirl(TURN_SPEED);	// 

			// Ə͍Ă邯ǁAKȂČĂȂ܂ܒԌoOɌ
			if(getIsLock() && timer.at(MOVE_TIMER).getTime() >= 120)
			{
				timer.at(ATTACK_TIMER).setTime(BAZOOKA_TIME + BAZOOKA_DELAY);
				timer.at(BAZOOKA_TIMER).setTime(BAZOOKA_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
			// Ă
			else if(distToGirl > ATTACK_DIST + ALLOW_DIST)
			{
				spd.z = -SPEED;	// ߂Â
			}
			// ߂
			else if(distToGirl < ATTACK_DIST - ALLOW_DIST)
			{
				spd.z = SPEED;
			}
			else if(getIsLock())	// KɋāAƏĂ΍U
			{
				timer.at(ATTACK_TIMER).setTime(BAZOOKA_TIME + BAZOOKA_DELAY);
				timer.at(BAZOOKA_TIMER).setTime(BAZOOKA_TIME);
				timer.at(MOVE_TIMER).setTime(0, false);
			}
		}
	}

	// ړ
	body.loTranslate(spd);

	// }bvƂ̓蔻
	map->procHit(&body, &spd);

	// lƂ̓蔻
	procHit(boy->getBody());
	procHit(girl->getBody());

	pos = body.getInhPosition();	// L̈ʒuۑ
}

// U
void C_Bazooka01::attack()
{
	if(timer.at(ATTACK_TIMER).getTime() > 0)
	{
		if(timer.at(BAZOOKA_TIMER).getTime() == BAZOOKA_TIME)
		{
			atkSphere.push_back(new C_HitSphereModel(BAZOOKA_RAD, BAZOOKA_POWER, BAZOOKA_LIMIT, BAZOOKA_SPEED, true, ENEMY_SINGLE_ATTACK));
			atkSphere.back()->setMaterial(Red);
			atkSphere.back()->getMaterial()->setAlpha(0.7);
			atkSphere.back()->glMoveTo(pos);
			atkSphere.back()->glVec(body.getVec());
			atkSphere.back()->loTranslate(0.0, 0.0, -50.0);
			atkSphere.back()->loFocus(GetRand(-1, 1) * 0.1, 0.0, -1.0);	// ΂
			scene->entryModel(atkSphere.back());
		}
	}

	// ëړƏŏ
	for(unsigned int i = 0; i < atkSphere.size(); ++i)
	{
		// ĂȂ
		if(timer.at(EXPLOSION_TIMER).getTime() == -1)
		{
			atkSphere.at(i)->move();	// ëړ

			// ŎԂɂȂ邩Aǂ̓vC[ɓĂ甚
			if(atkSphere.at(i)->cntLimit() || map->isHit(atkSphere.at(i)) || boy->isHit(atkSphere.at(i)) || girl->isHit(atkSphere.at(i)))
			{
				atkSphere.back()->setRad(EXPLOSION_PRIMAL_SIZE);
				timer.at(EXPLOSION_TIMER).setTime(EXPLOSION_LIMIT);
				timer.at(BAZOOKA_TIMER).setTime(0);
			}
		}
		// 
		else
		{
			// EF[u܂L鎞Ԃł
			if(timer.at(EXPLOSION_TIMER).getTime() > EXPLOSION_LIMIT - EXPLOSION_CREATE_TIME)
			{
				atkSphere.back()->setRad(atkSphere.back()->getRad() + EXPLOSION_SPREAD_SIZE);
			}

			// e
			if(timer.at(EXPLOSION_TIMER).getTime() == 0)
			{
				scene->removeModel(atkSphere.back());		// eremove
				SAFE_DELETE(atkSphere.back());
				atkSphere.pop_back();

				// vC[AttackData菜
				boy->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
				girl->removeAttackData(id, ENEMY_SINGLE_ATTACK, 0);
			}
		}
	}
}