#pragma once

class C_Girl;		// zQƂ̖h~
class C_EnemyBase;

#include "Character.h"
#include "XController.h"

namespace Boy
{
	const int HP_MAX = 500;			// HP
	const double BOY_SPEED = 4.0;	// ړXs[h

	const int WEAK_PUNCH_DELAY = 10;			// p`̃fBC
	const int STRONG_PUNCH_DELAY = 30;			// p`̃fBC

	const int WEAK_PUNCH_LIMIT = 5;				// p`̓蔻肪c鎞(WEAK_PUNCH_DELAY)
	const int STRONG_PUNCH_LIMIT = 20;			// p`̓蔻肪c鎞(STRONG_PUNCH_DELAY)
	const int COMBO_ABLE_TIME = 20;				// R{Ȃ鎞

	const int WEAK_PUNCH_POWER = 5;				// p`̈З
	const int STRONG_PUNCH_POWER = 30;			// p`̈З

	const double AUTO_POINT_MAX_RANGE = 200.0;		// p`ɎŌ킹ő勗
	const double AUTO_POINT_MIN_COS = 0.25;			// p`ɎŌ킹ŏ]l
	const double AUTO_POINT_EASY_MAX_RANGE = 100.0;	// I[gp`ɎŔő勗
	const double AUTO_POINT_EASY_MIN_COS = 0.5;		// I[gp`ɎŔŏ]l

	const int AUTO_GURAD_TIME = 60;				// I[gK[hWJ܂ł̎ԏ

	const int WAVE_DELAY = 50;				// EF[ũfBC
	const int CHARGE_COMP_TIME = 60;		// EF[ũ`[W܂ł̎
	const int WAVE_CREATE_TIME = 10;		// EF[uL鎞
	const int WAVE_POWER = 30;				// EF[üЗ
	const int WAVE_LIMIT = 20;				// EF[u܂ł̎
	const double WAVE_PRIMAL_SIZE = 40.0;	// EF[ȕTCY
	const double WAVE_SPREAD_SIZE = 8.0;	// EF[ut[ɍL傫

	const double GAUGE_POS_X = 320.0;		// HPQ[WXW
	const double GAUGE_POS_Y = 300.0;		// HPQ[WYW
	//const double GAUGE_SIZE_COEF = 0.5;		// HPQ[W̌W
	const double GAUGE_SIZE_X = 250.0;		// HPQ[W̉
	//const double GAUGE_SIZE_Y = 10.0;		// HPQ[W̏c

	enum Timer
	{
		ATTACK_DELAY_TIMER,
		COMBO_TIMER,
		CHARGE_TIMER,
		WAVE_TIMER,
		HEAL_TIMER,
		AUTO_GUARD_TIMER,
		TIMER_MAX
	};
}

namespace Heal
{
	const double HEAL_DIST = 200.0;				// 񕜂Lȋ
	const int HEAL_PENALTY_TIME = 60;			// ̉񕜂ŉт鎞
	const int HEAL_COMP_PRIMAL_TIME = 180 - HEAL_PENALTY_TIME;		// 񕜂܂ł̏
};

class C_Boy : public C_Character
{
private:
	// L̕ݒ̂߂̕ϐ
	double	RX;
	double	RY;
	double	magnitudeR;

	bool	guard_flag;			// K[hĂ邩ǂ
	fkut_BlockModel	guardBlock;	// K[hĂ邩ǂ킩悤

	int		punchNum;		// p`
	int		deathNum;		// _E(girlƋL)

	C_Girl					*girl;
	vector<C_EnemyBase *>	*enemyArray;

public:
	C_Boy(fk_Scene *, fk_Model *, C_MapBase *, C_Girl *, vector<C_EnemyBase *> *);
	~C_Boy();

	// V[؂ւĂvC[HPƃ_E񐔂p߁AÓIoϐɂĂ
	// ʏC_CharacterhpgAV[؂ւɂɕۑĂ
	static int BOY_HP;
	static int DEATH_NUM;

	void	move();			// ړ
	void	attack();		// U
	bool	attackJudge();	// UƂ̔f
	void	heal();			// 

	void	procDamage();	// UꂽƂ̏

	int		getPunchNum();
	
	void	setDeathNum(int num);
	int		getDeathNum();
};