#include "Debug.h"

C_Debug::C_Debug(fk_Window *argWin, C_EventManager *argEve)
: C_SceneBase(argWin, argEve)
, cursorPos(0)
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);

	// effBXvCXgɓo^
	scene.entryModel(&lightModel);

	// 摜̓ǂݍ
	if(debugImg.readPNG("Data/CG/TH.png") == false)	fl_alert("debugImg File Read Error!");

	// J[\
	cursor.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	cursor.drawText("");
	//cursor.setPositionLT(-80.0, 300.0);
	cursor.setPositionLT(-80.0, 300.0 - cursorPos * 30.0);
	cursor.entryFirst(ref_window, &scene, &camera);

	// j[
	for(int i = 0; i < sizeof(strList) / sizeof(strList[0]); ++i)	strList[i].initFont("C:/WINDOWS/Fonts/Meiryo.ttc");

	strList[0].drawText("TITLE");
	strList[1].drawText("STAGE1_1A");
	strList[2].drawText("STAGE1_1B");
	strList[3].drawText("STAGE1_2");
	strList[4].drawText("STAGE1_3");
	strList[5].drawText("GAME CLEAR");
	strList[6].drawText("GAME OVER");
	strList[7].drawText("EXIT");

	for(int i = 0; i < sizeof(strList) / sizeof(strList[0]); ++i)
	{
		strList[i].setPositionLT(-50.0, 300.0 - i * 30.0);
		strList[i].entryFirst(ref_window, &scene, &camera);
	}

	sound.b_setAllVolume(sound.b_getAllVolume());	// BGM̉ʂZbg

	//fadeIn(true, 30, false, b_title, b_debug);
	fadeIn(true, 30);
}

C_Debug::~C_Debug(void)
{
	//fadeOut(true, 30, true, b_title, b_debug);
	//sound.b_stop(b_title);
	//sound.b_stop(b_debug);
	fadeOut(true, 30);
}

int	C_Debug::onPeriod(void)
{
	// J[\̏cړ																		L[{[hp
	if( (controller[0].KeyDown(X_GAMEPAD_LS_DOWN) || controller[0].KeyDown(X_GAMEPAD_DOWN) || ref_event->getSpecialKeyStatus(FK_DOWN) == FKUT_SW_DOWN)
		|| (controller[0].getPressCount(X_GAMEPAD_LS_DOWN) >= 20 && controller[0].getPressCount(X_GAMEPAD_LS_DOWN) % 3 == 0)
		|| (controller[0].getPressCount(X_GAMEPAD_DOWN) >= 20 && controller[0].getPressCount(X_GAMEPAD_DOWN) % 3 == 0) )
	{
		if(cursorPos == Debug::LIST_MAX - 1)	cursorPos = 0;
		else									cursorPos++;

		cursor.setPositionLT(-80.0, 300.0 - cursorPos * 30.0);

		sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
	}

	if( (controller[0].KeyDown(X_GAMEPAD_LS_UP) || controller[0].KeyDown(X_GAMEPAD_UP) || ref_event->getSpecialKeyStatus(FK_UP) == FKUT_SW_DOWN)
		|| (controller[0].getPressCount(X_GAMEPAD_LS_UP) >= 20 && controller[0].getPressCount(X_GAMEPAD_LS_UP) % 3 == 0)
		|| (controller[0].getPressCount(X_GAMEPAD_UP) >= 20 && controller[0].getPressCount(X_GAMEPAD_UP) % 3 == 0) )
	{
		if(cursorPos == 0)	cursorPos = Debug::LIST_MAX - 1;
		else				cursorPos--;

		cursor.setPositionLT(-80.0, 300.0 - cursorPos * 30.0);

		sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
	}

	if(controller[0].KeyDown(X_GAMEPAD_A) || ref_event->getKeyStatus('Z') == FKUT_SW_DOWN)
	{
		sound.se_on(SE_DECISION);	// 艹̉

		switch(cursorPos)
		{
		case Debug::TITLE:
			return TITLE;
		case Debug::STAGE1_1A:
			return STAGE1_1A;
		case Debug::STAGE1_1B:
			return STAGE1_1B;
		case Debug::STAGE1_2:
			return STAGE1_2;
		case Debug::STAGE1_3:
			return STAGE1_3;
		case Debug::GAME_CLEAR:
			return GAME_CLEAR;
		case Debug::GAME_OVER:
			return GAME_OVER;
			//break;
		case Debug::EXIT:
			return -1;
		}
	}

	//sound.b_play(b_title);
	//sound.b_play(b_debug);

	return 0;
}