#pragma once
//#include "Smoke.h"
#include "SceneBase.h"

namespace Debug
{
	enum List
	{
		TITLE,
		STAGE1_1A,
		STAGE1_1B,
		STAGE1_2,
		STAGE1_3,
		GAME_CLEAR,
		GAME_OVER,
		EXIT,
		LIST_MAX
	};
}

class C_Debug : public C_SceneBase
{
private:
	fk_Model			lightModel;
	fk_Light			light;

	fkut_SpriteModel	debugImg;

	fkut_SpriteModel	cursor;
	int					cursorPos;

	fkut_SpriteModel	strList[Debug::LIST_MAX];

public:
	C_Debug(fk_Window *, C_EventManager *);
	~C_Debug(void);

	// V[vZXs
	int	onPeriod(void);
};