#include "FrameController.h"

//======================================================
//RXgN^
//======================================================
fkut_FrameController::fkut_FrameController(DWORD dwFps, bool bFrameSkip)
{
	memset(this,0,sizeof(fkut_FrameController));
	m_bInit = 1;
	m_bFrameSkip = bFrameSkip;
	SetFPS(dwFps);
	timeBeginPeriod(1);
}


//======================================================
//fXgN^
//======================================================
fkut_FrameController::~fkut_FrameController()
{
	timeEndPeriod(1);
}

//======================================================
//ŎԐ܂B
//======================================================
void fkut_FrameController::TimeRegular()
{
	m_dwFrameCount++;

	m_count++;
	if(m_count >= 60)	SetCount(0);
	
	if(m_bInit == 1)
	{
		m_dwLastMinitues = timeGetTime();
		m_bInit = 0;
		m_bDrawFlag = 1;
		return;
	}

	if(m_bFrameSkip == 1 && timeGetTime()  > (DWORD)((m_dwFrameCount + 1) * m_fFrameTime + m_dwLastMinitues))
	{
		m_bDrawFlag = 0;
		m_dwSkipCount++;
	}
	else
	{
		//===========================================================
		//̈ړƂŖʂȉZ炵܂B
		//			timeGetTime() - m_dwLastMinitues <= (DWORD)((m_dwFrameCount + 1) * m_fFrameTime)
		//̈ړ		timeGetTime()  <= (DWORD)((m_dwFrameCount + 1) * m_fFrameTime) +  m_dwLastMinitues
		//ϐu	timeGetTime()@<= dwTime
		//===========================================================
		DWORD dwTime = (DWORD)(m_dwFrameCount * m_fFrameTime + m_dwLastMinitues);
		while(timeGetTime() <= dwTime)
		{
			Sleep(1);
		}
		m_bDrawFlag = 1;
	}

	
	if(timeGetTime() - m_dwLastMinitues >= 1000)
	{
		m_dwLastMinitues = timeGetTime();
		m_dwFrameRate = m_dwFrameCount;
		m_dwFrameCount = 0;
		m_dwSkipRate = m_dwSkipCount;
		m_dwSkipCount = 0;
	}
}

//==================================================
//őt[[g𑪒肵܂B
//==================================================
void fkut_FrameController::Measure()
{
	m_dwFrameCount++;
	m_bDrawFlag = 1;
	if(timeGetTime() - m_dwLastMinitues >= 1000)
	{
		m_dwLastMinitues = timeGetTime();
		m_dwFrameRate = m_dwFrameCount;
		m_dwFrameCount = 0;
		m_dwSkipRate = m_dwSkipCount;
		m_dwSkipCount = 0;
	}	
}

//======================================================
//t[XLbv邩Ȃݒ肵܂B
//======================================================
void fkut_FrameController::OnFrameSkip(bool bFrameSkip)
{
	m_bFrameSkip = bFrameSkip;
}

//======================================================
//FPSݒ肷B
//======================================================
void fkut_FrameController::SetFPS(DWORD fps)
{
	m_fFrameTime = 1000.0f / fps;
}


//======================================================
//Ńt[[g擾܂B
//======================================================
DWORD fkut_FrameController::GetFrameRate()
{
	return m_dwFrameRate;
}

//======================================================
//ŃXLbv[g擾܂B
//======================================================
DWORD fkut_FrameController::GetSkipRate()
{
	return m_dwSkipRate;
}

//======================================================
//`悷邩Ȃ𔻒
//======================================================
bool fkut_FrameController::GetDrawFlag()
{
	return m_bDrawFlag;
}

//======================================================
//m_countZbg
//======================================================
void fkut_FrameController::SetCount(unsigned int argCount)
{
	m_count = argCount;
}

//======================================================
//m_countQbg
//======================================================
unsigned int fkut_FrameController::GetCount()
{
	return m_count;
}