#pragma once
#include <FK/FK.h>

class fkut_SpriteModel : public fk_Model {
private:
	friend class fkut_SimpleWindow;

	fk_RectTexture	texShape;
	fk_Material		absMate;
	fk_Model		pixelBase;

	fk_UniStr		textStr;
	bool			fontReady;

	static double	distPut;

public:
	// XvCg̕ϐ.text.`Ƃ邱ƂŃeLXgׂ̍ȑݒł܂
	// ڍׂFKt@X}jAfk_TextImageQƂĂ
	fk_TextImage	text;

	fkut_SpriteModel(void);
	~fkut_SpriteModel(void);

	// (bdl)̊֐privatepublicɕύXAV[ɃGg[O
	// \WindowScenẽ|C^nĂ
	void		MakePixelBase(fk_Window *argWin, fk_Scene *argScn);

	// ŏɃGg[鎞́Å֐gĂ
	// V[ɂ̓JZbgς݂łKv܂
	// EBhETCYEJEˉeύXꍇ͂xĂ΂ȂƃTCYȂ܂
	bool		entryFirst(fk_Window *argWin, fk_Scene *argScn, fk_Model *argCam = NULL);

	// 摜ǂݍ݂܂(PNĜݓ߉摜ɑΉĂ܂)
	bool		readBMP(const string argFileName);
	bool		readPNG(const string argFileName);
	bool		readJPG(const string argFileName);

	// ʓrpӂfk_Imagegpꍇ͂ŃZbg܂
	void		setImage(fk_Image &argImg);
	// ݎgpĂ摜QƂ܂(܂ςɂƗ邩܂)
	fk_Image *	getImage(void);

	// w肵WɂȂ悤ɈʒuύX܂
	void		setPositionLT(double x, double y);

	// w肵WEɂȂ悤ɈʒuύX܂
	void		setPositionRT(double x, double y);

	// w肵WɂȂ悤ɈʒuύX܂
	void		setPositionLB(double x, double y);

	// w肵WEɂȂ悤ɈʒuύX܂
	void		setPositionRB(double x, double y);

	// 摜̈ꕔ\̈ƂĐ؂o܂
	// w肷鐔l͉摜̍Wnł(ʓIȃeNX`WnĉBĂ܂)
	void		setSpriteArea(double left, double top, double width, double height);

	// 摜̕\TCYύX܂
	// ʏ͉摜̐ݒ莞ɎsĂ܂̂ŁAĂTCYύXɎg܂
	void		setSpriteSize(double width = -1.0, double height = -1.0);
	fk_TexCoord	getSpriteSize(void);

	// 摜̕\@ύX܂
	// Ԃtrue(炩[h)ɂĂ܂AtHg̏ꍇfalse̕₷ꍇ܂
	void		setSpriteSmoothMode(bool flag);
	bool		getSpriteSmoothMode(void);

	// \̂߂̏s܂
	// ɂ͎gtHg̃t@Cw肵܂
	// Vistaȍ~ł΃CI₷̂ŁA߂ł(t@CpX"C:/WINDOWS/Fonts/Meiryo.ttc"ł)
	bool		initFont(const string argFontFile);

	// ̕\s܂
	// ɕ\w肵܂
	// 2boolln֐ł́AtruenƂ܂łɓ͂A
	// falsenƂ܂łɓ͂ւ̕ts܂BboollnȂo[ẂA
	// falsen̂ƓɂȂ܂BR[hWindowsłȂȗō\܂)
	// \@ύXꍇ͎OɁuXvCg̕ϐ.text.`vŐݒ肵܂
	void		drawText(const string argStr, fk_StringCode argCode = FK_STR_SJIS);
	void		drawText(const string argStr, bool clearFlag, fk_StringCode argCode = FK_STR_SJIS);
};
