#include "GameMain.h"
#include <iostream>
#include <fstream>

C_GameMain::C_GameMain(Fl_Window *argMainWin, fk_Window *argDrawWin)
: C_GameBase(argMainWin, argDrawWin)	// eNX̃RXgN^Ăяo
, now_scene(NULL)
, sceneNum(0)
{
	return;
}

C_GameMain::~C_GameMain(void)
{
	SAFE_DELETE(now_scene);
}

void C_GameMain::init(void)
{
	SAFE_DELETE(now_scene);

	// ŏ̃V[
	//now_scene = new C_Stage1_1A(drawWin, &eveMan);
	//now_scene = new C_Stage1_3(drawWin, &eveMan);
	//now_scene = new C_Debug(drawWin, &eveMan);
	now_scene = new C_Title(drawWin, &eveMan);

	return;
}

bool C_GameMain::procLoop(void)
{
	// ႢŃV[NULL܂܂I
	if(now_scene == NULL)	return false;

	// V[1t[̏ĂяoČʂŕ
	switch(now_scene->onPeriod())
	{
	case 0:				// V[p
		return true;
	case TITLE:			// ^Cg
		SAFE_DELETE(now_scene);
		now_scene = new C_Title(drawWin, &eveMan);
		return true;
	case STAGE1_1A:		// Xe[W1_1A
		SAFE_DELETE(now_scene);
		now_scene = new C_Stage1_1A(drawWin, &eveMan);
		return true;
	case STAGE1_1B:		// Xe[W1_1B
		SAFE_DELETE(now_scene);
		now_scene = new C_Stage1_1B(drawWin, &eveMan);
		return true;
	case STAGE1_2:		// Xe[W1_2
		SAFE_DELETE(now_scene);
		now_scene = new C_Stage1_2(drawWin, &eveMan);
		return true;
	case STAGE1_3:		// Xe[W1_3
		SAFE_DELETE(now_scene);
		now_scene = new C_Stage1_3(drawWin, &eveMan);
		return true;
	case GAME_CLEAR:	// Q[NAʂ
		SAFE_DELETE(now_scene);
		now_scene = new C_GameClear(drawWin, &eveMan);
		return true;
	case GAME_OVER:		// Q[I[o[ʂ
		sceneNum = now_scene->getStageNum();
		SAFE_DELETE(now_scene);
		now_scene = new C_GameOver(drawWin, &eveMan, sceneNum);
		return true;
	case DEBUG_MODE:	// fobO[h
		SAFE_DELETE(now_scene);
		now_scene = new C_Debug(drawWin, &eveMan);
		return true;
	default:			// ȊO̒lł͏I
		return false;
	}

	return false;
}