#pragma once
#include "FKUT/CubicModel.h"

class C_HitBlockModel : public fkut_BlockModel
{
protected:
	fk_Vector		spd;
	int				power;
	bool			isCE;			// ǂ
	int				kind;			// U̎
	int				index;			// z̔ԍ

	int				limit;			// ł܂ł̎
	bool			limit_flag;		// ŎԂtrue

	double			sizeX, sizeY, sizeZ;	// setSize()ŕύX

public:
	C_HitBlockModel(double x, double y, double z, int argPower, int argLimit, fk_Vector argSpd, bool argCE_flag, int argKind = -1, int argIndex = 0);
	C_HitBlockModel(double x, double y, double z, int argPower, int argLimit, bool argCE_flag, int argKind = -1, int argIndex = 0);
	virtual ~C_HitBlockModel();

	void			setSpd(fk_Vector argSpd);
	fk_Vector		getSpd();

	void			setPower(int argPower);
	int				getPower();

	void			setCE_flag(bool argFlag);
	bool			getCE_flag();

	void			setKind(int argKind);
	int				getKind();

	void			setIndex(int argIndex);
	int				getIndex();

	void			setLimit(int argLimit);
	int				getLimit();

	void			setLimit_flag(bool argFlag);
	bool			getLimit_flag();

	void			setSize(double x, double y, double z);	// sizeX,Y,ZύXăubNĐ
	double			getSizeX();
	double			getSizeY();
	double			getSizeZ();

	bool			cntLimit();	// limit炵A0ɂȂtrueԂ

	virtual	void	move();

	// 蔻菈
	void			procHit(fkut_BlockModel *OBB, fk_Vector *spd);		// Փˏ(߂)s(OBBp)
	void			procHit(fkut_SphereModel *sphere, fk_Vector *spd);	// Փˏ(߂)s(p)
	bool			isHit(fkut_BlockModel *OBB);						// Ă邩ǂ(OBBp)
	bool			isHit(fkut_SphereModel *sphere);					// Ă邩ǂ(p)
};