#include "Title.h"

C_Title::C_Title(fk_Window *argWin, C_EventManager *argEve)
: C_SceneBase(argWin, argEve)
, ti_cursorPos(0)
, option_flag(false)
, op_cursorPos(0)
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);

	// effBXvCXgɓo^
	scene.entryModel(&lightModel);

	// 摜̓ǂݍ
	if(titleImg.readPNG("Data/CG/TAG HEROES.png") == false)	fl_alert("titleImg File Read Error!");
	if(optionImg.readJPG("Data/CG/TH-Bat.jpg") == false)	fl_alert("optionImg File Read Error!");
	
	if(b_volumeImg.readPNG("Data/CG/volume.png") == false)	fl_alert("volumeImg File Read Error!");
	if(se_volumeImg.readPNG("Data/CG/volume.png") == false)	fl_alert("volumeImg File Read Error!");

	telop.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	telop.drawText("^Cg");
	telop.setPositionLT(-640.0, 360.0);
	telop.entryFirst(ref_window, &scene, &camera);

	// ^Cg
	titleImg.glMoveTo(0.0, 50.0, 0.0);
	titleImg.entryFirst(ref_window, &scene, &camera);

	// ^CgJ[\
	ti_cursor.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	ti_cursor.drawText("");
	ti_cursor.glMoveTo(-100.0, -300.0, 0.0);
	ti_cursor.setParent(&titleImg);
	ti_cursor.entryFirst(ref_window, &scene, &camera);

	// ^Cg
	for(int i = 0; i < Title::STR_MAX; ++i)	ti_str[i].initFont("C:/WINDOWS/Fonts/Meiryo.ttc");

	ti_str[0].drawText("GAME START");
	ti_str[1].drawText("OPTION");
	ti_str[2].drawText("EXIT");

	for(int i = 0; i < Title::STR_MAX; ++i)
	{
		ti_str[i].glMoveTo(0.0, -300.0 - i * 35.0, 0.0);
		ti_str[i].setParent(&titleImg);
		ti_str[i].entryFirst(ref_window, &scene, &camera);
	}

	// IvVJ[\
	op_cursor.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	op_cursor.drawText("");
	op_cursor.setPositionLT(1000.0, 200.0);
	op_cursor.setParent(&titleImg);
	op_cursor.entryFirst(ref_window, &scene, &camera);

	// IvV
	for(int i = 0; i < Option::STR_MAX; ++i)	op_str[i].initFont("C:/WINDOWS/Fonts/Meiryo.ttc");

	op_str[0].drawText("BGM VOLUME");
	op_str[1].drawText("SE VOLUME");
	op_str[2].drawText("VIBRATION");
	op_str[3].drawText("ACTION TYPE");
	op_str[4].drawText("OK");

	for(int i = 0; i < Option::STR_MAX; ++i)
	{
		op_str[i].setPositionLT(1050.0, 200.0 - i * 100.0);
		op_str[i].setParent(&titleImg);
		op_str[i].entryFirst(ref_window, &scene, &camera);
	}

	// BGM
	b_volumeImg.setSpriteSmoothMode(false);
	b_volumeImg.setSpriteSize(sound.b_getAllVolume() * VOLUME_GAUGE);
	b_volumeImg.setPositionLT(1250.0, 200.0);
	b_volumeImg.setParent(&titleImg);
	b_volumeImg.entryFirst(ref_window, &scene, &camera);

	// SE
	se_volumeImg.setSpriteSmoothMode(false);
	se_volumeImg.setSpriteSize(sound.se_getAllVolume() * VOLUME_GAUGE);
	se_volumeImg.setPositionLT(1250.0, 100.0);
	se_volumeImg.setParent(&titleImg);
	se_volumeImg.entryFirst(ref_window, &scene, &camera);

	// oCu[V
	vib_on.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	vib_on.drawText("ON");
	vib_on.setPositionLT(1290.0, 0.0);
	vib_on.setParent(&titleImg);
	vib_on.entryFirst(ref_window, &scene, &camera);

	vib_off.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	vib_off.drawText("OFF");
	vib_off.setPositionLT(1465.0, 0.0);
	vib_off.setParent(&titleImg);
	vib_off.entryFirst(ref_window, &scene, &camera);

	if(controller[0].getVib_flag())
	{
		vib_on.setMaterial(Red);
		vib_off.setMaterial(Gray2);
	}
	else
	{
		vib_on.setMaterial(Gray2);
		vib_off.setMaterial(Red);
	}

	// ^Cv
	type_auto.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	type_auto.drawText("AUTO");
	type_auto.setPositionLT(1280.0, -100.0);
	type_auto.setParent(&titleImg);
	type_auto.entryFirst(ref_window, &scene, &camera);

	type_manual.initFont("C:/WINDOWS/Fonts/Meiryo.ttc");
	type_manual.drawText("MANUAL");
	type_manual.setPositionLT(1455.0, -100.0);
	type_manual.setParent(&titleImg);
	type_manual.entryFirst(ref_window, &scene, &camera);

	if(controller[0].getIsAuto())
	{
		type_auto.setMaterial(Red);
		type_manual.setMaterial(Gray2);
	}
	else
	{
		type_auto.setMaterial(Gray2);
		type_manual.setMaterial(Red);
	}

	sound.b_setAllVolume(sound.b_getAllVolume());	// BGM̉ʂZbg

	fadeIn(true, 30, false, B_TITLE);
}

C_Title::~C_Title(void)
{
	fadeOut(true, 60, true, B_TITLE);
	sound.b_stop(B_TITLE);
}

int	C_Title::onPeriod(void)
{
	// ^Cg
	if(option_flag == false)
	{
		// J[\̏cړ																		L[{[hp
		if( (controller[0].KeyDown(X_GAMEPAD_LS_DOWN) || controller[0].KeyDown(X_GAMEPAD_DOWN) || ref_event->getSpecialKeyStatus(FK_DOWN) == FKUT_SW_DOWN)
			|| (controller[0].getPressCount(X_GAMEPAD_LS_DOWN) >= 20 && controller[0].getPressCount(X_GAMEPAD_LS_DOWN) % 3 == 0)
			|| (controller[0].getPressCount(X_GAMEPAD_DOWN) >= 20 && controller[0].getPressCount(X_GAMEPAD_DOWN) % 3 == 0) )
		{
			if(ti_cursorPos == Title::STR_MAX - 1)	ti_cursorPos = 0;
			else									ti_cursorPos++;

			ti_cursor.glMoveTo(-100.0, -300.0 - ti_cursorPos * 35.0, 0.0);

			sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
		}

		if( (controller[0].KeyDown(X_GAMEPAD_LS_UP) || controller[0].KeyDown(X_GAMEPAD_UP) || ref_event->getSpecialKeyStatus(FK_UP) == FKUT_SW_DOWN)
			|| (controller[0].getPressCount(X_GAMEPAD_LS_UP) >= 20 && controller[0].getPressCount(X_GAMEPAD_LS_UP) % 3 == 0)
			|| (controller[0].getPressCount(X_GAMEPAD_UP) >= 20 && controller[0].getPressCount(X_GAMEPAD_UP) % 3 == 0) )
		{
			if(ti_cursorPos == 0)	ti_cursorPos = Title::STR_MAX - 1;
			else					ti_cursorPos--;

			ti_cursor.glMoveTo(-100.0, -300.0 - ti_cursorPos * 35.0, 0.0);

			sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
		}

		if(controller[0].KeyDown(X_GAMEPAD_A) || ref_event->getKeyStatus('Z') == FKUT_SW_DOWN)
		{
			// Q[X^[g
			if(ti_cursorPos == Title::GAME_START)
			{
				sound.se_on(SE_DECISION);
				return STAGE1_1A;
			}

			// IvVʂֈړ
			if(ti_cursorPos == Title::OPTION)
			{
				option_flag = true;
				sound.se_on(SE_CURSOR_MOVE);

				// IvVʂ̃J[\ԏ
				op_cursorPos = 0;
				op_cursor.setPositionLT(1000.0, 200.0);

				telop.drawText("IvV", true);
				telop.setPositionLT(-640.0, 360.0);
				int pos = 0;
				while(titleImg.getPosition().x != -1280.0)
				{
					pos += 20;
					titleImg.glMoveTo(0.0 - pos, 50.0, 0.0);
					ref_window->drawWindow();
					Fl::check();
					sound.se_play();
				}
			}

			// Q[I
			if(ti_cursorPos == Title::EXIT)	return -1;
		}
	}
	// IvV
	else
	{
		// J[\̏cړ																		L[{[hp
		if( (controller[0].KeyDown(X_GAMEPAD_LS_DOWN) || controller[0].KeyDown(X_GAMEPAD_DOWN) || ref_event->getSpecialKeyStatus(FK_DOWN) == FKUT_SW_DOWN)
			|| (controller[0].getPressCount(X_GAMEPAD_LS_DOWN) >= 20 && controller[0].getPressCount(X_GAMEPAD_LS_DOWN) % 3 == 0)
			|| (controller[0].getPressCount(X_GAMEPAD_DOWN) >= 20 && controller[0].getPressCount(X_GAMEPAD_DOWN) % 3 == 0) )
		{
			if(op_cursorPos == Option::STR_MAX - 1)	op_cursorPos = 0;
			else									op_cursorPos++;

			op_cursor.setPositionLT(1000.0, 200.0 - op_cursorPos * 100.0);

			sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
		}

		if( (controller[0].KeyDown(X_GAMEPAD_LS_UP) || controller[0].KeyDown(X_GAMEPAD_UP) || ref_event->getSpecialKeyStatus(FK_UP) == FKUT_SW_DOWN)
			|| (controller[0].getPressCount(X_GAMEPAD_LS_UP) >= 20 && controller[0].getPressCount(X_GAMEPAD_LS_UP) % 3 == 0)
			|| (controller[0].getPressCount(X_GAMEPAD_UP) >= 20 && controller[0].getPressCount(X_GAMEPAD_UP) % 3 == 0) )
		{
			if(op_cursorPos == 0)	op_cursorPos = Option::STR_MAX - 1;
			else					op_cursorPos--;

			op_cursor.setPositionLT(1000.0, 200.0 - op_cursorPos * 100.0);

			sound.se_on(SE_CURSOR_MOVE);	// J[\ړ̉
		}

		// BGM̉ʒ
		if(op_cursorPos == Option::BGM_VOLUME)
		{
			if( (controller[0].KeyDown(X_GAMEPAD_LS_RIGHT) || controller[0].KeyDown(X_GAMEPAD_RIGHT) || ref_event->getSpecialKeyStatus(FK_RIGHT) == FKUT_SW_DOWN)
				|| (controller[0].getPressCount(X_GAMEPAD_LS_RIGHT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_LS_RIGHT) % 1 == 0*/)
				|| (controller[0].getPressCount(X_GAMEPAD_RIGHT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_RIGHT) % 1 == 0*/) )
			{
				if(sound.b_getAllVolume() < 1.0 && controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					sound.b_setAllVolume(sound.b_getAllVolume() + 0.01);
					b_volumeImg.setSpriteSize(sound.b_getAllVolume() * VOLUME_GAUGE);
					b_volumeImg.setPositionLT(1250.0, 200.0);
					sound.se_on(SE_CURSOR_MOVE);
				}
			}

			if( (controller[0].KeyDown(X_GAMEPAD_LS_LEFT) || controller[0].KeyDown(X_GAMEPAD_LEFT) || ref_event->getSpecialKeyStatus(FK_LEFT) == FKUT_SW_DOWN)
				|| (controller[0].getPressCount(X_GAMEPAD_LS_LEFT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_LS_LEFT) % 1 == 0*/)
				|| (controller[0].getPressCount(X_GAMEPAD_LEFT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_LEFT) % 1 == 0*/) )
			{
				if(sound.b_getAllVolume() > 0.0 && controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					// 덷l
					if(0.01 - EPS <= sound.b_getAllVolume() && sound.b_getAllVolume() <= 0.01 + EPS)
					{
						sound.b_setAllVolume(0.0);
					}
					else
					{
						sound.b_setAllVolume(sound.b_getAllVolume() - 0.01);
					}
					b_volumeImg.setSpriteSize(sound.b_getAllVolume() * VOLUME_GAUGE);
					b_volumeImg.setPositionLT(1250.0, 200.0);
					sound.se_on(SE_CURSOR_MOVE);
				}
			}
		}

		// SẺʒ
		if(op_cursorPos == Option::SE_VOLUME)
		{
			if( (controller[0].KeyDown(X_GAMEPAD_LS_RIGHT) || controller[0].KeyDown(X_GAMEPAD_RIGHT) || ref_event->getSpecialKeyStatus(FK_RIGHT) == FKUT_SW_DOWN)
				|| (controller[0].getPressCount(X_GAMEPAD_LS_RIGHT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_LS_RIGHT) % 3 == 0*/)
				|| (controller[0].getPressCount(X_GAMEPAD_RIGHT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_RIGHT) % 3 == 0*/) )
			{
				if(sound.se_getAllVolume() < 1.0 && controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					sound.se_setAllVolume(sound.se_getAllVolume() + 0.01);
					se_volumeImg.setSpriteSize(sound.se_getAllVolume() * VOLUME_GAUGE);
					se_volumeImg.setPositionLT(1250.0, 100.0);
					sound.se_on(SE_CURSOR_MOVE);
				}
			}

			if( (controller[0].KeyDown(X_GAMEPAD_LS_LEFT) || controller[0].KeyDown(X_GAMEPAD_LEFT) || ref_event->getSpecialKeyStatus(FK_LEFT) == FKUT_SW_DOWN)
				|| (controller[0].getPressCount(X_GAMEPAD_LS_LEFT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_LS_LEFT) % 3 == 0*/)
				|| (controller[0].getPressCount(X_GAMEPAD_LEFT) >= 20/* && controller[0].getPressCount(X_GAMEPAD_LEFT) % 3 == 0*/) )
			{
				if(sound.se_getAllVolume() > 0.0 && controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					if(0.01 - EPS <= sound.se_getAllVolume() && sound.se_getAllVolume() <= 0.01 + EPS)
					{
						sound.se_setAllVolume(0.0);
					}
					else
					{
						sound.se_setAllVolume(sound.se_getAllVolume() - 0.01);
					}
					se_volumeImg.setSpriteSize(sound.se_getAllVolume() * VOLUME_GAUGE);
					se_volumeImg.setPositionLT(1250.0, 100.0);
					sound.se_on(SE_CURSOR_MOVE);
				}
			}
		}

		// U@\̐ݒ
		if(op_cursorPos == Option::VIBRATION)
		{
			if(controller[0].KeyDown(X_GAMEPAD_LS_RIGHT) || controller[0].KeyDown(X_GAMEPAD_RIGHT) || ref_event->getSpecialKeyStatus(FK_RIGHT) == FKUT_SW_DOWN)
			{
				if(controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					if(controller[0].getVib_flag())
					{
						for(int i = 0; i < MAX_CONTROLLERS; ++i)	controller[i].setVib_flag(false);

						vib_on.setMaterial(Gray2);
						vib_off.setMaterial(Red);
						sound.se_on(SE_CURSOR_MOVE);
					}
				}
			}

			if(controller[0].KeyDown(X_GAMEPAD_LS_LEFT) || controller[0].KeyDown(X_GAMEPAD_LEFT) || ref_event->getSpecialKeyStatus(FK_LEFT) == FKUT_SW_DOWN)
			{
				if(controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					if(!controller[0].getVib_flag())
					{
						for(int i = 0; i < MAX_CONTROLLERS; ++i)	controller[i].setVib_flag(true);

						vib_on.setMaterial(Red);
						vib_off.setMaterial(Gray2);
						sound.se_on(SE_CURSOR_MOVE);
						controller[0].vib_on(65535, 65535, 10, 10);
					}
				}
			}
		}

		// Rg[ݒ
		if(op_cursorPos == Option::ACTION_TYPE)
		{
			if(controller[0].KeyDown(X_GAMEPAD_LS_RIGHT) || controller[0].KeyDown(X_GAMEPAD_RIGHT) || ref_event->getSpecialKeyStatus(FK_RIGHT) == FKUT_SW_DOWN)
			{
				if(controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					if(controller[0].getIsAuto())
					{
						for(int i = 0; i < MAX_CONTROLLERS; ++i)	controller[i].setIsAuto(false);

						type_auto.setMaterial(Gray2);
						type_manual.setMaterial(Red);
						sound.se_on(SE_CURSOR_MOVE);
					}
				}
			}

			if(controller[0].KeyDown(X_GAMEPAD_LS_LEFT) || controller[0].KeyDown(X_GAMEPAD_LEFT) || ref_event->getSpecialKeyStatus(FK_LEFT) == FKUT_SW_DOWN)
			{
				if(controller[0].KeyRelease(X_GAMEPAD_LS_UP) && controller[0].KeyRelease(X_GAMEPAD_LS_DOWN))
				{
					if(!controller[0].getIsAuto())
					{
						for(int i = 0; i < MAX_CONTROLLERS; ++i)	controller[i].setIsAuto(true);

						type_auto.setMaterial(Red);
						type_manual.setMaterial(Gray2);
						sound.se_on(SE_CURSOR_MOVE);
					}
				}
			}
		}

		// ^Cgɖ߂
		if(op_cursorPos == Option::OK)
		{
			if(controller[0].KeyDown(X_GAMEPAD_A) || ref_event->getKeyStatus('Z') == FKUT_SW_DOWN)
			{
				option_flag = false;
				sound.se_on(SE_CURSOR_MOVE);

				telop.drawText("^Cg", true);
				telop.setPositionLT(-640.0, 360.0);
				int pos = 0;
				while(titleImg.getPosition().x != 0.0)
				{
					pos += 20;
					titleImg.glMoveTo(-1280.0 + pos, 50.0, 0.0);
					ref_window->drawWindow();
					Fl::check();
					sound.se_play();
				}
			}
		}
	}

	// fobOʂ
	if(controller[0].KeyDown(X_GAMEPAD_BACK) || ref_event->getSpecialKeyStatus(FK_F9) == FKUT_SW_DOWN)
	{
		sound.se_on(SE_DECISION);
		return DEBUG_MODE;
	}

	sound.b_play(B_TITLE);

	return 0;
}