#pragma once
#pragma comment(lib, "XInput.lib")
#include <windows.h>
#include <XInput.h>

const int MAX_CONTROLLERS = 1;  // Rg[[̍ő吔

// XBOXRg[[̃L[
enum XKey
{
	X_GAMEPAD_A,			// A{^
	X_GAMEPAD_B,			// B{^
	X_GAMEPAD_X,			// X{^
	X_GAMEPAD_Y,			// Y{^
	X_GAMEPAD_UP,			// \L[
	X_GAMEPAD_DOWN,			// \L[
	X_GAMEPAD_LEFT,			// \L[
	X_GAMEPAD_RIGHT,		// \L[E
	X_GAMEPAD_NEUTRAL,		// \L[j[g
	X_GAMEPAD_LB,			// LB
	X_GAMEPAD_RB,			// RB
	X_GAMEPAD_LPUSH,		// XeBbN
	X_GAMEPAD_RPUSH,		// EXeBbN
	X_GAMEPAD_BACK,			// obN{^
	X_GAMEPAD_START,		// X^[g{^
	X_GAMEPAD_LS_UP,		// XeBbN
	X_GAMEPAD_LS_DOWN,		// XeBbN
	X_GAMEPAD_LS_LEFT,		// XeBbN
	X_GAMEPAD_LS_RIGHT,		// XeBbNE
	X_GAMEPAD_LS_NEUTRAL,	// XeBbNj[g
	X_GAMEPAD_RS_UP,		// EXeBbN
	X_GAMEPAD_RS_DOWN,		// EXeBbN
	X_GAMEPAD_RS_LEFT,		// EXeBbN
	X_GAMEPAD_RS_RIGHT,		// EXeBbNE
	X_GAMEPAD_RS_NEUTRAL,	// EXeBbNj[g
	X_GAMEPAD_LT,			// LT
	X_GAMEPAD_RT,			// RT
	X_GAMEPAD_MAX,			// L[̍ő吔
};

// XBOXRg[[NX
class C_XController
{
private:
	bool Connected;	// ڑĂ邩

	bool oldKeyState[X_GAMEPAD_MAX];	// 1[vO̓͏Ԃۑ
	bool newKeyState[X_GAMEPAD_MAX];	// ݂̓͏Ԃۑ

	int pressCount[X_GAMEPAD_MAX];		// ǂꂭ炢Ă邩

	XINPUT_VIBRATION vibration;			// U@\
	bool vib_flag;						// U@\gǂ
	int	leftVibTimer, rightVibTimer;	// U
	
	bool isAuto;						// I[g[hǂ

public:
	C_XController();	// RXgN^
	~C_XController();	// fXgN^

	XINPUT_STATE state;					// Xe[^X

	HRESULT UpdateControllerState();	// Rg[[̏ԂXV

	bool KeyDown(int key);		// u
	bool KeyPress(int key);		// Ă
	bool KeyUp(int key);		// u
	bool KeyRelease(int key);	// Ă

	int	getPressCount(int key);	// pressCount擾

	void vib_on(int left, int right, int leftTimer, int rightTimer);	// U͂
	void vibControl();				// UԂ𐧌䂷

	void setVib_flag(bool flag);	// U@\ON/OFF
	bool getVib_flag();				// U@\ONȂtrue, OFFȂfalseԂ

	void setIsAuto(bool flag);		// I[g[hON/OFF
	bool getIsAuto();				// I[g[hONȂtrue, OFFȂfalseԂ
};

extern C_XController controller[MAX_CONTROLLERS];	// XBOXRg[[NX錾