#pragma once

#include <FK/FK.h>

class C_DX3File
{
private:
	double			timeCount;					// [V^C
	double			looptime;					// [v鎞
	double			startmotiontime;			// [V̊Jnʒu
	bool			loopset;					// [v邩Ȃ̃tO
	fk_BVHMotion	DX3_BVH;					// BVH[V蓖ă

public:
	C_DX3File(void);							// RXgN^
	~C_DX3File(void);							// fXgN^

	fk_IFSTexture			DX3_IFSTexture;

	void		init(void);						// 

	void		load(const string &,const string &);				// Xt@CƃeNX`t@C[h iXt@C̃pX,eNX`(bmp,jpg,png)̃pXj

	void		Motion_play(double);								// [VĐ iĐxj
	void		Motion_loopsetting(bool,double,double);				// [VĐݒ itrueŃ[v,[VJn,[v܂ł̎ԐݒA0ȉŌێj
	void		Motion_set(fk_BVHMotion *,bool,double,double);		// ɓǂݍ܂ĂBVHf[^ZbgA (fk_BVHMotionf[^,trueŃ[v,[VJn,[v܂ł̎ԐݒA0ȉœǂݍ܂ꂽBVH̍ŏIt[Zbgj
	void		Motion_loadset(const string &,bool,double,double);	// VKBVHǂݍ݁AZbgAxȂ肻A񐄏 (fk_BVHMotionpX,trueŃ[v,[VJn,[v܂ł̎ԐݒA0ȉœǂݍ܂ꂽBVH̍ŏIt[Zbgj
};

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ȉAXt@C̃f𑍊NX

enum XModel
{
	X_BOY,
	X_GIRL,
	X_ASSASSIN01,
	X_ASSAULT_RIFLE01,
	X_BAZOOKA01,
	X_BOMB01,
	X_BOSS01,
	X_HAMMER01,
	X_PUNCH01,
	X_RUSH01,
	X_SHIELD01,
	X_SWORD01,
	X_MAX,
};

class C_XModel
{
private:

public:
	C_XModel();
	~C_XModel();

	C_DX3File	model[X_MAX];	// Xt@C̃fi[Ă߂̔z

	void init();				// 
};

extern C_XModel xModel;